'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});
var _bind = Function.prototype.bind;

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

var _common = require('./common');

/**
 * @class Controller
 */

var Controller = (function () {
  function Controller() {
    _classCallCheck(this, Controller);
  }

  _createClass(Controller, null, [{
    key: 'register',

    /**
     * Registers controller on the app with the name of the class in camelcase.
     * @param app
     */
    value: function register(app) {
      app.controller((0, _common.toCamelCase)(this.name), this);
    }
  }]);

  return Controller;
})();

exports.Controller = Controller;

var Service = (function () {
  function Service() {
    _classCallCheck(this, Service);
  }

  _createClass(Service, null, [{
    key: 'register',
    value: function register(app) {
      app.service((0, _common.toCamelCase)(this.name), this);
    }
  }]);

  return Service;
})();

exports.Service = Service;

var Factory = (function () {
  function Factory() {
    _classCallCheck(this, Factory);
  }

  _createClass(Factory, null, [{
    key: 'register',
    value: function register(app) {
      app.factory((0, _common.toCamelCase)(this.name), this);
    }
  }]);

  return Factory;
})();

exports.Factory = Factory;

var Directive = (function () {
  function Directive() {
    _classCallCheck(this, Directive);
  }

  _createClass(Directive, null, [{
    key: 'register',
    value: function register(app) {
      var _this = this;

      // noinspection JSUnresolvedVariable,JSUnresolvedVariable,JSUnresolvedVariable
      app.directive((0, _common.toCamelCase)(this.name), function () {
        for (var _len = arguments.length, params = Array(_len), _key = 0; _key < _len; _key++) {
          params[_key] = arguments[_key];
        }

        return new (_bind.apply(_this, [null].concat(params)))();
      });
    }
  }]);

  return Directive;
})();

exports.Directive = Directive;